/*
  CGI module

  T. Nakagawa

  2009/01/12
*/


#include <string.h>
#include <avr/io.h>
#include "uip.h"
#include "cgi.h"
#include "httpd.h"
#include "fs.h"


void cgi_option(u8_t p, u8_t q) {
  u8_t port;

  port = PORTC & ~0x0f;

  for (; p + 2 < q; p += 4) {
    if (uip_appdata[p] == 's' && uip_appdata[p + 1] == '=') {
      if (uip_appdata[p + 2] == '2') {
        port |= _BV(0);
      } else if (uip_appdata[p + 2] == '3') {
        port |= _BV(1);
      } else if (uip_appdata[p + 2] == '4') {
        port |= _BV(2);
      } else if (uip_appdata[p + 2] == '5') {
        port |= _BV(3);
      }
    }
  }
  PORTC = port;

  return;
}


u8_t cgi_exec(void) {
  unsigned char i;
  unsigned char pin;

  if(uip_acked()) {
    return 1;
  }
  strcpy((char *)uip_appdata, "<input type=checkbox name=s value=0 disabled checked>LEDx\n");
  uip_appdata[34] = hs->script[0];
  if (hs->script[0] < '2') {	/* Switch */
    uip_appdata[53] = 'S';
    uip_appdata[54] = 'W';
    uip_appdata[55] = hs->script[0];
    uip_appdata[56] = ' ';
    if (hs->script[0] == '0') {
      pin = PINC & 0x10;
    } else {
      pin = PINC & 0x20;
    }
    if (pin) {
      for (i = 45; i < 45 + 7; i++) uip_appdata[i] = ' ';
    }
  } else {	/* LED */
    uip_appdata[56] = hs->script[0] - 2;
    if (hs->script[0] == '2') {
      pin = PORTC & 0x01;
    } else if (hs->script[0] == '3') {
      pin = PORTC & 0x02;
    } else if (hs->script[0] == '4') {
      pin = PORTC & 0x04;
    } else {
      pin = PORTC & 0x08;
    }
    if (!pin) {
      for (i = 45; i < 45 + 7; i++) uip_appdata[i] = ' ';
    }
    for (i = 36; i < 36 + 8; i++) uip_appdata[i] = ' ';
  }

  uip_send(uip_appdata, 58);

  return 0;
}
